;;*****************************************************************************
;; File: BubblerScreenPrint.asm -- originally XC.BUB
;;       Part of source code for Commodore 64 version of Bubbler
;;       See comment at start of Bubbler.asm for more details

;
;
;
; File XC.BUB
; Starts Here
;
; XC - Matthew's screen print routines
;
DNTPRNT	RTS

HTPPLANE	JSR FTPPLNCDS

	;check for print

	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	STA ZPA

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

	BNE DNTPRNT

	;bcc dntprnt

	LDA ZPA

	CMP LINEC

	BCS DNTPRNT



	LDX SRT0+1 ;Qx hi

	LDY #1

	LDA ZPA

	SEC

	SBC YSM

	BCS LEFTTYP1

	DEY

	LDA YSM

	SEC

	SBC ZPA

	SBC #8

LEFTTYP1	ASL ; = ASL A ;*2

	;clc

	ADC SRT0 ;Qx lo

	BCC FINLTYP

	INX

FINLTYP	STA ZPB

	STX ZPB+1

	STY DATA

	CMP ZPD ;Sx+w

	TXA

	SBC ZPD+1

	BCS DNTPRNT

	LDX SRT0+1 ;Qx hi

	LDA ZPA

	CMP XSM

	BCS RIGHTTYP1

	ADC YSM

	JMP FINRTYP

RIGHTTYP1	LDA LINEC

	CLC

	ADC XSM

	SEC

	SBC ZPA

	SBC #8

FINRTYP	ASL ; = ASL A ;*2

	;clc

	ADC SRT0 ;Qx lo

	BCC LZ50020

	INX

LZ50020	STA ZPC

	STX ZPC+1

	CMP STRIPX

	TXA

	SBC STRIPX+1

	BCS LZ441

	RTS ;dont print

LZ441	;find how far along strip to start printing

	LDA ZPB

	SEC

	SBC STRIPX

	TAX

	LDA ZPB+1

	SBC STRIPX+1

	BCS PRLHTRI

	;left half triangle is off left of strip

	LDA STRIPX

	SEC

	SBC ZPB

	LSR ; = LSR A
	LSR ; = LSR A
	LSR ; = LSR A
	LSR ; = LSR A ;/16

	AND #1

	EOR DATA

	STA DATA

	LDA STRIPX

	STA ZPB

	LDA STRIPX+1

	STA ZPB+1

	JSR DOTDOFFMD

	JMP LHSRTIN

	;print left half triangle

PRLHTRI	JSR STRDALNG ;fix STRIPDAT

	JSR DOTDOFFMD

	LDY POS ;data offset

	JSR DO1TRI

	LDA POS

	LDX POS+1

	STA POS+1

	STX POS

PRHTRLOOP	LDA STRIPDAT ;move ptr in work area along 2 bytes

	CLC

	ADC #2

	STA STRIPDAT

	BCC LZ443

	INC STRIPDAT+1

	CLC

LZ443	LDA ZPB

	ADC #$10

	STA ZPB

	BCC LZ444

	INC ZPB+1

LZ444	CMP ZPD ;Sx+w

	LDA ZPB+1

	SBC ZPD+1

	BCS EXPHSTR ;branch if RHS of strip reached

LHSRTIN	LDA ZPB

	CMP ZPC ;Trightx

	LDA ZPB+1

	SBC ZPC+1

	BCS PRLSHTRI ;branch if reached final triangle (RHS of plane strip)

	JSR DO2TRIS

	JMP PRHTRLOOP



PRLSHTRI	;print right half triangle

	JSR SWOPPTRS ;swop data ptrs for "1st" & "2nd" triangles

	LDA POS+1

	AND #$20

	TAY

	JMP DO1TRI

EXPHSTR	RTS



DOTDOFFMD	LDX #$00

	LDY #$20

	LDA DATA

	BNE LZ446

	STX POS

	STY POS+1

	RTS

LZ446	STX POS+1

	STY POS

DONOTPRNT	RTS





HSSIDSQP1	JSR SIDSQSUB

	LDY #$D

	LDA (ZPG),Y ;zdim

	STA YSM

	;check for print

	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	STA ZPA

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

	BNE DONOTPRNT

	;bcc donotprint

	LDA YSM ;zdim

	CLC

	ADC XSM ;xdim/2

	CMP ZPA

	BCC DONOTPRNT

	BEQ DONOTPRNT

	LDY #0

	LDX SRT0+1 ;Qx hi

	LDA ZPA

	CMP XSM ;xdim/2

	BCS RGHTEDSTR

	ASL ; = ASL A ;*2

	BCC LZ452

	INX

	CLC

LZ452	ADC SRT0 ;Qx lo

	BCC FINSQRTED

	INX

	JMP FINSQRTED

RGHTEDSTR	INY

	LDA XSM ;xdim/2

	ASL ; = ASL A ;*2

	ADC SRT0 ;Qx lo

	BCC LZ470

	INX

LZ470	SEC

	SBC #$10

	BCS FINSQRTED

	DEX

FINSQRTED	STA ZPC

	STX ZPC+1

HTRI1ENT	STY DATA+1

	;check in strip range

	CMP STRIPX

	TXA

	SBC STRIPX+1

	BCC DONOTPRNT

	LDX SRT0+1 ;Qx hi

	LDY #0

	LDA ZPA

	SEC

	SBC YSM ;zdim

	BCS HSQLTYP0

	INY

	LDA ZPA

	ASL ; = ASL A
	ASL ; = ASL A ;[*8]*4=*$20

	AND #$20

	STA POS

	LDA SRT0 ;Qx lo

	JMP FINHSLTYP

HSQLTYP0	STY POS

	ASL ; = ASL A ;*2

	;clc

	ADC SRT0 ;Qx lo

	BCC FINHSLTYP

	INX

FINHSLTYP	STA ZPB

	STX ZPB+1

	STY DATA

	;check in strip range

	CMP ZPD

	TXA

	SBC ZPD+1

	BCC LZ473

EXHPRRSQ	RTS ;dont print

LZ473	;find how far along strip to start

DRSTHSQSTA	LDA #0

DRSTHSQSTR	STA PTR

	LDA ZPB

	SEC

	SBC STRIPX

	TAX

	LDA ZPB+1

	SBC STRIPX+1

	BCC LZ50010

	JMP HSQSTSTRP

LZ50010	;start part way across plane strip

	TXA

	ASL ; = ASL A ;[*$10]*2=*$20

	EOR POS

	AND #$20

	STA POS

	LDA STRIPX

	STA ZPB

	LDA STRIPX+1

	STA ZPB+1

	LDA DATA

	BPL LZ50009

	CMP #$FE

	BEQ LZ50009

	JSR SETDATPCC

LZ50009	JMP HSQPRMDEN

	;extra routines for triangular strips

FCNGFTTR	JSR SETDATP13

	LDY #0

	JSR DO1TRI

	AND #0

	STA POS

	JSR SETDATPAA

	JMP HSQPRNTLP



DOLTRTSL	INY

	BEQ THRTTR

	INY

	BEQ FCNGFTTR



FORTTR	LDA ZPA

	LSR ; = LSR A
	LSR ; = LSR A
	LSR ; = LSR A

	TAX

	LDY AREM3,X

	STY ZPA ;data offset

	JSR DO1TRI

	JSR SETDATPCC

	LDY DATA

	DEY

	BMI EXHPRRSQ ;branch if at RHS of plane strip

	LDA POS

	CLC

	ADC #$20

	AND #$20

	STA POS

	LDA ZPA ;data offset

	CMP #$40

	BEQ PRXTRATR

	JMP HSQPRNTLP

THRTTR	LDA POS

	PHA

	LDA ZPA

	AND #$08

	ASL ; = ASL A
	ASL ; = ASL A ;[*8]*4=*$20

	TAY ;data offset

	BEQ LZ50008

	LDA ZPA

	AND #$10

	BEQ LZ50008

	LDY #$40

LZ50008	JSR DO1TRI

	JSR SETDATPCC

	PLA

	CLC

	ADC #$20

	AND #$20

	STA POS

	BEQ HSQPRNTLP

	LDA ZPA

	AND #8

	BEQ HSQPRNTLP

	LDA ZPB

	CMP ZPC

	LDA ZPB+1

	SBC ZPC+1

	BCC PRXTRATR ;branch if not reached RHS of plane strip

	RTS

PRXTRATR	LDY #0

	JSR DO1TRI

	JMP HSQPRNTLP

GODOLTRTSL JMP DOLTRTSL

	;print left edge of strip

HSQSTSTRP	JSR STRDALNG ;fix STRIPDAT

	LDY DATA

;;	BMI DOLTRTSL    Gives "branch out of range"
	BMI GODOLTRTSL

	BNE HSQPRMDEN

	LDY DATA+1

	BPL NOCTTLST

	LDA ZPB

	SEC

	SBC ZPC

	TAX

	LDA ZPB+1

	SBC ZPC+1

	BCS PRHEDSQST ;branch if reached RHS of plane strip

NOCTTLST	LDA PTR ;data offset

	EOR #$40

	TAY

PRHLTSSQ	JSR DO1TRI

	LDA #$20

	STA POS



HSQPRNTLP	LDA STRIPDAT ;move ptr in work area along 2 bytes

	CLC

	ADC #2

	STA STRIPDAT

	BCC LZ457

	INC STRIPDAT+1

	CLC

LZ457	LDA ZPB

	ADC #$10

	STA ZPB

	BCC LZ458

	INC ZPB+1

LZ458	CMP ZPD ;Sx+w

	LDA ZPB+1

	SBC ZPD+1

;;	BCS EXPRHSQSTR ;branch if RHS of strip reached ; Gives "Branch out of range"
        BCC HSQPRMDEN
        RTS ; JMP EXPRHSQSTR

HSQPRMDEN	LDA ZPB

	SEC

	SBC ZPC

	TAX

	LDA ZPB+1

	SBC ZPC+1

	BCS PRHEDSQST ;branch if reached RHS of plane strip

ONELASTTM	LDA POS

	AND #$20

	BNE HPRMBYTELK

	STA POS+1 ;=0

	JSR DO2SECS

	JMP HSQPRNTLP

HPRMBYTELK	AND #0

	STA POS

	LDY #$20 ;data offset

	JSR DO1TRI

	JMP HSQPRNTLP



PRHEDSQST	LDY DATA+1 ;RHS end type

	BMI PENDTRS1

	BEQ HSQPRTRI

	DEY

	BNE EXPRHSQSTR

	TXA

	BNE EXPRHSQSTR

	INC DATA+1

	JMP ONELASTTM

HSQPRTRI	LDY PTR ;data offset

	JMP DO1TRI



PENDTRS1	DEY

	BPL OKFTSLJ

	DEY

	BMI OKTHSL

OKFTSLJ	JMP OKFRTSL



OKTHSL	CPY #$C0

	BNE RLYTHT

	JSR SETDATP12

	LDY #0 ;data offset

	JMP DO1TRI



RLYTHT	TXA

	BNE EXPRHSQSTR

	JSR SETDATPA

	LDA ZPA

	ASL ; = ASL A
	ASL ; = ASL A ;[*8]*4=*$20

	AND #$20

	TAY

	BEQ PEDTS1B

	LDA ZPA

	AND #$10

	BNE PEDTS1A

PEDTS1B	JMP DO1TRI

PEDTS1A	LDY #$40

	JSR DO1TRI

	LDY DATA+1

	INY

	BEQ EXPRHSQSTR

PEDTS1Z	JSR SETDATPAA

	LDY #0 ;data offset

	JMP DO1TRI



EXPRHSQSTR	RTS



HSSIDSQP2	JSR DSIDSQSB

	;check for print

	LDY #$D

	LDA (ZPG),Y ;zdim

	STA XSM

	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	STA ZPA

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

	BNE EXPRHSQSTR ;dont print

	;bcc exprhsqstr

	LDA XSM ;zdim

	CLC

	ADC YSM ;ydim/2

	CMP ZPA

	BCC EXPRHSQSTR ;dont print

	BEQ EXPRHSQSTR ;dont print

	LDY #0

	LDX SRT0+1 ;Qx hi

	LDA ZPA

	SEC

	SBC YSM ;ydim/2

	BCS HSQ2LTP1

	STY POS ;=0

	LDA YSM ;ydim/2

	SEC

	SBC ZPA

	ASL ; = ASL A

	SEC

	SBC #$10

	CLC

	ADC SRT0 ;Qx lo

	BCC FNHSQ2LTP

	INX

	JMP FNHSQ2LTP

HSQ2LTP1	INY

	ASL ; = ASL A
	ASL ; = ASL A ;[*8]*4=*$20

	AND #$20

	EOR #$20

	STA POS

	LDA SRT0

FNHSQ2LTP	STA ZPB

	STX ZPB+1

	STY DATA

	CMP ZPD

	TXA

	SBC ZPD+1

	BCS EXPRHSQSTR ;dont print

DRTPLIN	LDY #0

	LDX SRT0+1 ;Qx hi

	LDA ZPA

	CMP XSM ;zdim

	BCC HSQ2RTP1

	LDA YSM ;ydim/2

	CLC

	ADC XSM ;zdim

	SEC

	SBC ZPA

	ASL ; = ASL A ;*2

	JMP CHTADD7

HSQ2RTP1	INY

	LDA YSM ;ydim/2

	ASL ; = ASL A ;*2

CHTADD7	SEC

	SBC #$10

	CLC

	ADC SRT0 ;Qx lo

	BCC FNRTPHSQ2

	INX

FNRTPHSQ2	STA ZPC

	STX ZPC+1

	STY DATA+1

	CMP STRIPX

	TXA

	SBC STRIPX+1

	BCC DONTPRNT

	LDA #$40

	JMP DRSTHSQSTR ;rest is nearly same as for plane 4

DONTPRNT	RTS ;dont print





HSLOPFC1	JSR SLPFCSB

	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	STA ZPA

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

	BNE DONTPRNT

	;bcc dontprnt

	LDA LINEC ;(xdim+ydim)/2

	CLC

	ADC XSM ;xdim/2

	CMP ZPA

	BCC DONTPRNT

	BEQ DONTPRNT

	LDY #0

	LDX SRT0+1 ;Qx hi

	LDA ZPA

	;sec

	SBC YSM

	BCC HTHLTP0

	INY

	PHA

	ASL ; = ASL A
	ASL ; = ASL A ;[*8]*4=*$20

	AND #$20

	CLC

	ADC #$20

	STA POS

	PLA

	AND #$F0

	CLC

	JMP CHTADD5

HTHLTP0	STY POS

	LDA YSM

	SEC

	SBC ZPA

	;sec

	SBC #8

	ASL ; = ASL A ;*2

	;clc

CHTADD5	ADC SRT0 ;Qx lo

	BCC FNHTHLTP

	INX

FNHTHLTP	STA ZPB

	STX ZPB+1

	STY DATA

	CMP ZPD

	TXA

	SBC ZPD+1

	BCS DONTPRNT

	LDY #0

	LDX SRT0+1 ;Qx hi

	LDA XSM

	ASL ; = ASL A ;*2

	STA ZPC ;temp

	LDA ZPA

	SEC

	SBC ZPC

	BCC HTHRTP0

	ASL ; = ASL A ;*2

	STA ZPC ;temp

	LDA LINEC

	ASL ; = ASL A ;*2

	SEC

	SBC ZPC

	SEC

	SBC #$10

	JMP CHTADD6

HTHRTP0	INY

	LDA YSM

	ASL ; = ASL A ;*2

	;clc

	ADC ZPA

	AND #$F0

CHTADD6	CLC

	ADC SRT0 ;Qx lo

	BCC FHTHRTP

	INX

FHTHRTP	STA ZPC

	STX ZPC+1

	STY DATA+1

	CMP STRIPX

	TXA

	SBC STRIPX+1

	BCS LZ4105

NOMORPRNT	RTS ;dont print

LZ4105	;find how far along strip to start printing

	LDA ZPB

	;sec

	SBC STRIPX

	TAX

	LDA ZPB+1

	SBC STRIPX+1

	BCS PRTHLHTR

	;LH triangle is off left of strip

	LDA STRIPX

	SEC

	SBC ZPB

	LSR ; = LSR A
	LSR ; = LSR A
	LSR ; = LSR A
	LSR ; = LSR A ;/$10

	TAX

	LDA AREM3,X

	CLC

	ADC POS

	CMP #$60

	BCC LZ4108

	SBC #$60

LZ4108	STA POS

	LDA STRIPX

	STA ZPB

	LDA STRIPX+1

	STA ZPB+1

	JMP HPTHMENT

PRTHLHTR	;print LH triangle

	JSR STRDALNG ;fix STRIPDAT

	LDY POS

	JSR DO1TRI

	CPY #$60

	BCC PREHTHPL

	LDY #0

PREHTHPL	STY POS



HPRTHSLP	LDA STRIPDAT

	CLC

	ADC #2

	STA STRIPDAT

	BCC LZ4112

	INC STRIPDAT+1

	CLC

LZ4112	LDA ZPB

	ADC #$10

	STA ZPB

	BCC LZ4113

	INC ZPB+1

LZ4113	CMP ZPD ;Sx+w

	LDA ZPB+1

	SBC ZPD+1

	BCS NOMORPRNT ;branch if RHS of strip reached

HPTHMENT	LDA ZPB ;Tleftx

	CMP ZPC ;Trightx

	LDA ZPB+1

	SBC ZPC+1

	BCS PLHTHTR ;branch if reached final tri (RHS of plane strip)

	LDA POS

	CMP #$60

	BCC LZ4114

	AND #0

	STA POS

	CLC

LZ4114	ADC #$40

	CMP #$60

	BCC LZ4115

	SBC #$60

LZ4115	STA POS+1

	JSR DO2SECS

	JMP HPRTHSLP



PLHTHTR	LDA POS

	BNE LZ4116

	LDA #$60

LZ4116	CLC

	ADC #$40

	TAY

	JMP DO1TRI





NOPRNTPL	RTS

HSLOPFC2	JSR SLPFCSB

	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	STA ZPA

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

	BNE NOPRNTPL

	;bcc noprntpl

	LDA LINEC ;(xdim+ydim)/2

	CLC

	ADC YSM ;ydim/2

	CMP ZPA

	BCC NOPRNTPL

	BEQ NOPRNTPL

	LDY #0

	LDX SRT0+1 ;Qx hi

	LDA YSM

	ASL ; = ASL A ;=ydim

	CMP ZPA

	BCC HRTSLTT0

	BEQ HRTSLTT0

	INY

	LDA ZPA

	AND #$08

	ASL ; = ASL A
	ASL ; = ASL A ;[*8]*4=*$20

	STA POS

	LDA ZPA

	AND #$F0

	STA ZPB ;temp

	LDA YSM

	ASL ; = ASL A

	SEC

	SBC ZPB

	SBC #$10

	JMP CHTADD3

HRTSLTT0	LDA #$40

	STA POS

	LDA ZPA

	SEC

	SBC YSM

	SBC YSM ;=sbc 2(ysm)

	ASL ; = ASL A ;*2

CHTADD3	CLC

	ADC SRT0 ;Qx lo

	BCC FINHRTLT

	INX

FINHRTLT	STA ZPB

	STX ZPB+1

	STY DATA

	CMP ZPD

	TXA

	SBC ZPD+1

;;	BCS NOPRNTPL    Gives "Branch out of range"
        BCC NOT_NOPRNTPL
        RTS ;; JMP NOPRNTPL

NOT_NOPRNTPL

	LDY #0

	LDX SRT0+1 ;Qx hi

	LDA ZPA

	CMP XSM

	BCC HRTHRT0

	INY

	ASL LINEC

	LDA XSM

	CLC

	ADC #8

	SEC

	SBC ZPA

	SEC

	SBC #$10

	AND #$F0

	CLC

	ADC LINEC

	CLC

	JMP CHTADD4

HRTHRT0	;lda zpa

	;clc

	ADC YSM

	ASL ; = ASL A

	;clc

CHTADD4	ADC SRT0 ;Qx lo

	BCC LZ4133

	INX

LZ4133	STA ZPC

	STX ZPC+1

	STY DATA+1

	CMP STRIPX

	TXA

	SBC STRIPX+1

	BCS LZ4134

PRNTNOMOR	RTS ;dont print

LZ4134	;find how far along strip to start printing

	LDA ZPB

	;sec

	SBC STRIPX

	TAX

	LDA ZPB+1

	SBC STRIPX+1

	BCS RPRTHLHTR

	;LH triangle is off left of strip

	LDA STRIPX

	SEC

	SBC ZPB

	LSR ; = LSR A
	LSR ; = LSR A
	LSR ; = LSR A
	LSR ; = LSR A ;/$10

	TAX

	LDA POS

	SEC

	SBC REM3,X

	BCS LZ50012

	ADC #$60

LZ50012	STA POS

	LDA STRIPX

	STA ZPB

	LDA STRIPX+1

	STA ZPB+1

	JMP RHPTHMENT

RPRTHLHTR	;print LH triangle

	JSR STRDALNG ;fix STRIPDAT

	LDY POS

	JSR DO1TRI

	CPY #$60

	BCC RPREHTHPL

	LDY #0

RPREHTHPL	STY POS



RHPRTHSLP	LDA STRIPDAT

	CLC

	ADC #2

	STA STRIPDAT

	BCC RLZ4112

	INC STRIPDAT+1

	CLC

RLZ4112	LDA ZPB

	ADC #$10

	STA ZPB

	BCC RLZ4113

	INC ZPB+1

RLZ4113	CMP ZPD ;Sx+w

	LDA ZPB+1

	SBC ZPD+1

	BCS PRNTNOMOR ;branch if RHS of strip reached

RHPTHMENT	LDA ZPB ;Tleftx

	CMP ZPC ;Trightx

	LDA ZPB+1

	SBC ZPC+1

	BCS RPLHTHTR ;branch if reached final tri (RHS of plane strip)

	LDA POS

	CLC

	ADC #$20

	CMP #$60

	BCC RLZ4114

	SBC #$60

RLZ4114	STA POS

	CLC

	ADC #$20

	CMP #$60

	BCC RLZ4115

	SBC #$60

RLZ4115	STA POS+1

	JSR DO2SECS

	JMP RHPRTHSLP



RPLHTHTR	JSR SWOPPTRS

	LDA POS

	CLC

	ADC #$40

	CMP #$60

	BCC LZ4137

	SBC #$60

LZ4137	TAY

	JMP DO1TRI





FNPLPRNT	RTS

HFSLPFC1	JSR SLPFCSB

	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	STA ZPA

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

	BNE FNPLPRNT

	;bcc fnplprnt

	LDA XSM

	ASL ; = ASL A ;*2

	;clc

	ADC LINEC

	BCS TLGTTST ;branch if=$0100

	CMP ZPA

	BEQ FNPLPRNT

	BCC FNPLPRNT

TLGTTST	;ldy #0

	LDX SRT0+1 ;Qx hi

	LDA ZPA

	;sec

	SBC YSM ;ydim/2

	BCC HFTLTP0

	LSR ; = LSR A
	LSR ; = LSR A
	LSR ; = LSR A ;/8

	TAY

	LDA REM3,Y

	STA POS

	LDA DIV3,Y

	LDY #1

	JMP CHTADDA

HFTLTP0	LDY #0

	STY POS

	LDA YSM

	SEC

	SBC ZPA

	ASL ; = ASL A

	SEC

	SBC #$10

CHTADDA	CLC

	ADC SRT0 ;Qx lo

	BCC FINHFLT

	INX

FINHFLT	STA ZPB

	STX ZPB+1

	STY DATA

	CMP ZPD

	TXA

	SBC ZPD+1

	BCS FNPLPRNT

	LDX SRT0+1 ;Qx hi

	LDA XSM

	ASL ; = ASL A ;*2

	;clc

	ADC XSM ;=*3

	STA ZPC ;temp

	LDA ZPA

	SEC

	SBC ZPC

	BCS HFTRT0

	LDA ZPA

	LSR ; = LSR A
	LSR ; = LSR A
	LSR ; = LSR A ;/8

	TAY

	LDA DIV3,Y

	CLC

	ADC YSM

	;clc

	ADC YSM

	JMP CHTADBYTE

HFTRT0	ASL ; = ASL A ;*2

	STA ZPC ;temp

	LDA LINEC

	ASL ; = ASL A

	SEC

	SBC ZPC

	SEC

	SBC #$10

CHTADBYTE	CLC

	ADC SRT0 ;Qx lo

	BCC FHFTRT

	INX

FHFTRT	STA ZPC

	STX ZPC+1

	CMP STRIPX

	TXA

	SBC STRIPX+1

	BCS LZ50001

ENHFTPR	RTS ;dont print

LZ50001	;find how far across to start printing

	LDA ZPB

	;sec

	SBC STRIPX

	TAX

	LDA ZPB+1

	SBC STRIPX+1

	BCS HFTPRLTR

	;LH tri is off left of strip

	LDA STRIPX

	SEC

	SBC ZPB

	AND #$3F

	ASL ; = ASL A ;[*$10]*2=*$20

	;clc

	ADC POS

	STA POS

	LDA STRIPX

	STA ZPB

	LDA STRIPX+1

	STA ZPB+1

	JMP HFTPMDIN

HFTPRLTR	;print LH tri

	JSR STRDALNG ;fix STRIPDAT

	LDY POS

	JSR DO1TRI

	STY POS



HFTPRLP	LDA STRIPDAT

	CLC

	ADC #2

	STA STRIPDAT

	BCC LZ50002

	INC STRIPDAT+1

	CLC

LZ50002	LDA ZPB

	ADC #$10

	STA ZPB

	BCC LZ50003

	INC ZPB+1

LZ50003	CMP ZPD ;Sx+w

	LDA ZPB+1

	SBC ZPD+1

	BCS ENHFTPR ;branch if RHS of strip reached

HFTPMDIN	LDA ZPB ;Tleftx

	CMP ZPC ;Trightx

	LDA ZPB+1

	SBC ZPC+1

	BCS PRLHFTTR ;branch if reached final tri (RHS of plane strip)

	LDA POS

	AND #$7F

	STA POS

	;clc

	ADC #$60

	AND #$7F

	STA POS+1

	JSR DO2SECS

	JMP HFTPRLP



PRLHFTTR	JSR SWOPPTRS

	LDA POS

	CLC

	ADC #$60

	AND #$7F

	TAY

	JMP DO1TRI



ENPLPRNT	RTS

HFSLPFC2	JSR SLPFCSB

	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	STA ZPA

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

	BNE ENPLPRNT

	;bcc enplprnt

	LDA YSM

	ASL ; = ASL A ;*2

	;clc

	ADC LINEC

	BCS TOOLTTST ;branch if=$0100

	CMP ZPA

	BEQ ENPLPRNT

	BCC ENPLPRNT

TOOLTTST	;ldy #0

	LDX SRT0+1 ;Qx hi

	LDA YSM

	ASL ; = ASL A ;*2

	;clc

	ADC YSM ;=*3

	STA ZPB ;temp

	LDA ZPA

	SEC

	SBC ZPB

	BCS HFT2LT0

	LDA ZPA

	LSR ; = LSR A
	LSR ; = LSR A
	LSR ; = LSR A ;/8

	TAY

	LDA AREM3,Y

	STA POS

	LDA YSM

	ASL ; = ASL A

	SEC

	SBC #$10

	SEC

	SBC DIV3,Y

	LDY #1

	CLC

	JMP CHTADDD

HFT2LT0	LDY #$60

	STY POS

	LDY #0

	ASL ; = ASL A

	;clc

CHTADDD	ADC SRT0 ;Qx lo

	BCC HFT2LTF

	INX

HFT2LTF	STA ZPB

	STX ZPB+1

	STY DATA

	CMP ZPD

	TXA

	SBC ZPD+1

;;	BCS ENPLPRNT    Gives "Branch out of range"
        BCC NOT_ENPLPRNT
        RTS ;; JMP ENPLPRNT

NOT_ENPLPRNT

	LDX SRT0+1 ;Qx hi

	LDA ZPA

	SEC

	SBC XSM

	BCC HFT2RT0

	LSR ; = LSR A
	LSR ; = LSR A
	LSR ; = LSR A ;/8

	TAY

	LDA LINEC

	ASL ; = ASL A ;*2

	SEC

	SBC #$10

	SEC

	SBC DIV3,Y

	CLC

	JMP CHTADDE

HFT2RT0	LDA ZPA

	CLC

	ADC YSM

	ASL ; = ASL A ;*2

	;clc

CHTADDE	ADC SRT0

	BCC HFT2FRT

	INX

HFT2FRT	STA ZPC

	STX ZPC+1

	CMP STRIPX

	TXA

	SBC STRIPX+1

	BCS LZ50004

XHFT2PR	RTS ;dont print

LZ50004	;find how far across to start printing

	LDA ZPB

	;sec

	SBC STRIPX

	TAX

	LDA ZPB+1

	SBC STRIPX+1

	BCS HFT2PLTR

	;LH tri is off left of strip

	LDA STRIPX

	SEC

	SBC ZPB

	AND #$3F

	ASL ; = ASL A ;[*$10]*2=*$20

	STA ZPB ;temp

	LDA POS

	SEC

	SBC ZPB

	CLC

	ADC #$40

	STA POS

	LDA STRIPX

	STA ZPB

	LDA STRIPX+1

	STA ZPB+1

	JMP HFT2PMIN

HFT2PLTR	;print LH tri

	JSR STRDALNG ;fix STRIPDAT

	LDY POS

	JSR DO1TRI

	STY POS



HFT2PLP	LDA STRIPDAT

	CLC

	ADC #2

	STA STRIPDAT

	BCC LZ50005

	INC STRIPDAT+1

	CLC

LZ50005	LDA ZPB

	ADC #$10

	STA ZPB

	BCC LZ50006

	INC ZPB+1

LZ50006	CMP ZPD ;Sx+w

	LDA ZPB+1

	SBC ZPD+1

	BCS XHFT2PR ;branch if RHS of strip reached

HFT2PMIN	LDA ZPB ;Tleftx

	CMP ZPC ;Trightx

	LDA ZPB+1

	SBC ZPC+1

	BCS PLHF2TTR ;branch if reached final tri (RHS of plane strip)

	LDA POS

	;clc

	ADC #$40

	AND #$7F

	STA POS

	CLC

	ADC #$20

	AND #$7F

	STA POS+1

	JSR DO2SECS

	JMP HFT2PLP



PLHF2TTR	JSR SWOPPTRS

	LDA POS

	CLC

	ADC #$60

	AND #$7F

	TAY

	JMP DO1TRI





NPRTHT1	RTS

HTRISL1	JSR SIDSQSUB

	LDA XSM ;=zdim

	STA YSM

	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	STA ZPA

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

	BNE NPRTHT1

	;bcc nprtht1

	LDA XSM

	ASL ; = ASL A ;*2

	SEC

	SBC ZPA

	BCC NPRTHT1

	BEQ NPRTHT1

	TAX

	LDA ZPA

	AND #$F0

	CLC

	ADC SRT0 ;Qx lo

	STA ZPC

	LDA SRT0+1

	ADC #0

	STA ZPC+1

	LDY #$FE

TRISLPSC	CPX #8

	BNE NTLSTTBT

	INY

NTLSTTBT	LDA ZPC

	LDX ZPC+1

	JMP HTRI1ENT





NPRTHT2	RTS

HTRISL2	JSR SIDSQSUB

	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	STA ZPA

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

	BNE NPRTHT2 ;dont print

	;bcc nprtht2

	LDA XSM

	ASL ; = ASL A ;=zdim

	STA YSM

	CLC

	ADC XSM

	SEC

	SBC ZPA

	BCC NPRTHT2

	BEQ NPRTHT2

	TAX

	LDA ZPA

	LSR ; = LSR A
	LSR ; = LSR A
	LSR ; = LSR A ;/8

	TAY

	LDA DIV3,Y

	CLC

	ADC SRT0 ;Qx lo

	STA ZPC

	LDA SRT0+1

	ADC #0

	STA ZPC+1

	LDY #$80

	JMP TRISLPSC



OKFRTSL	TXA

	BNE FNTRFRT

	JSR SETDATPB

	LDA ZPA

	LSR ; = LSR A
	LSR ; = LSR A
	LSR ; = LSR A ;/8

	TAX

	LDY AREM3,X

	CPY #$40

	BEQ PTFTTSL1

	JMP DO1TRI

PTFTTSL1	JSR DO1TRI

	LDY DATA+1

	DEY

	BMI FNTRFRT

	JMP PEDTS1Z

FNTRFRT	RTS





HRTRISL1	JSR RTRIPLS

	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	STA ZPA

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

	BNE FNTRFRT ;dont print

	;bcc fntrfrt

	LDA YSM ;=zdim

	STA XSM

	ASL ; = ASL A

	CMP ZPA

	BCC FNTRFRT

	BEQ FNTRFRT

	LDA ZPA

	AND #$F0

	STA ZPB ;temp

	LDA YSM

	ASL ; = ASL A

	SEC

	SBC ZPB

	;sec

	SBC #$10

	CLC

	ADC SRT0 ;Qx lo

	STA ZPB

	LDA SRT0+1 ;Qx hi

	ADC #0

	STA ZPB+1

	LDA ZPB

	CMP ZPD

	LDA ZPB+1

	SBC ZPD+1

	BCS FNTRFRT ;dont print

	LDA #$FF

	STA DATA

	LDA ZPA

	AND #$10

	ASL ; = ASL A

	STA POS

	LDA ZPA

	AND #8

	ASL ; = ASL A

	ASL ; = ASL A

	EOR POS

	STA POS

	JMP DRTPLIN





FNTRFT2	RTS

HRTRISL2	JSR RTRIPLS

	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	STA ZPA

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

;;	BNE FNTRFRT ;dont print ; Gives "Branch out of range"
	BNE FNTRFRT2 ;dont print

	;bcc fntrfrt

	LDA YSM ;=zdim

	ASL ; = ASL A ;*2

	STA XSM

	;clc

	ADC YSM ;=*3

	SEC

	SBC ZPA

;;	BCC FNTRFRT ; Gives "Branch out of range"
	BCC FNTRFRT2

;;	BEQ FNTRFRT ; Gives "Branch out of range"
	BEQ FNTRFRT2

	TAX

	LDA ZPA

	LSR ; = LSR A
	LSR ; = LSR A
	LSR ; = LSR A ;/8

	TAY

	LDA XSM ;zdim=2(YSM)

	SEC

	SBC DIV3,Y

	SBC #$10

	CLC

	ADC SRT0 ;Qx lo

	STA ZPB

	LDA SRT0+1 ;Qx hi

	ADC #0

	STA ZPB+1

	LDA ZPB

	CMP ZPD

	LDA ZPB+1

	SBC ZPD+1

	BCS FNTRFT2 ;dont print

	LDA #$80

	CPX #$08

	BNE LZ50011

	LDA #$81

LZ50011	STA DATA

	LDA AREM3,Y

	AND #$20

	STA POS

	JMP DRTPLIN




FNTRFRT2
NOPLPRN1	RTS

HSMLSSFC	JSR SIDSQSUB

	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	TAX

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

	BNE NOPLPRN1 ;dont print

	;bcc noplprn1

	TXA

	CMP XSM

	BCS NOPLPRN1 ;dont print

	STA ZPA

	LDX SRT0+1 ;Qx hi

	ASL ; = ASL A ;*2

	;clc

	ADC SRT0 ;Qx lo

	BCC LZ50013

	INX

LZ50013	STA ZPB

	STX ZPB+1

	CMP ZPD

	TXA

	SBC ZPD+1

	BCS NOPLPRN1 ;dont print

	AND #0

	STA PTR

	LDA YSM

SMLSQPCM	ASL ; = ASL A ;*2

	;clc

	ADC ZPB

	BCC LZ50014

	INX

LZ50014	STA ZPC

	STX ZPC+1

	CMP STRIPX

	TXA

	SBC STRIPX+1

	BCC NOPLPRN1 ;dont print

	;find how far across to start printing

	LDA ZPB

	;sec

	SBC STRIPX

	TAX

	LDA ZPB+1

	SBC STRIPX+1

	BCS PLTSMSSL

	;LH tri is off left of strip

	LDA STRIPX

	STA ZPB

	LDA STRIPX+1

	STA ZPB+1

	JMP HMINSMSQ

PLTSMSSL	;print LH tri

	JSR STRDALNG ;fix STRIPDAT

	LDY PTR

	JSR DO1TRI



HPSMSPLP	LDA STRIPDAT

	CLC

	ADC #2

	STA STRIPDAT

	BCC LZ50015

	INC STRIPDAT+1

	CLC

LZ50015	LDA ZPB

	ADC #$10

	STA ZPB

	BCC LZ50016

	INC ZPB+1

LZ50016	CMP ZPD ;Sx+w

	LDA ZPB+1

	SBC ZPD+1

;;	BCS NOPLPRN1 ;branch if RHS of strip reached    ; Gives "Branch out of range"
        BCS NOPLPRN2 ; Both NOPLPRN1 and NOPLPRN2 are RTS

HMINSMSQ	LDA ZPB ;Tleftx

	CMP ZPC ;Trightx

	LDA ZPB+1

	SBC ZPC+1

	BCS PRTSMSSL ;branch if reached final tri (RHS of plane strip)

	AND #0

	STA POS

	STA POS+1

	JSR DO2SECS

	JMP HPSMSPLP



PRTSMSSL	LDA PTR

	EOR #$20

	TAY

	JMP DO1TRI





NOPLPRN2	RTS

HRSMLSSF	JSR SMLSP2SB

	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	TAX

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

	BNE NOPLPRN2 ;dont print

	;bcc noplprn2

	TXA

	CMP YSM

	BCS NOPLPRN2 ;dont print

	STA ZPA

	LDX SRT0+1 ;Qx hi

	LDA YSM

	SEC

	SBC ZPA

	SBC #8

	ASL ; = ASL A

	;clc

	ADC SRT0 ;Qx lo

	BCC LZ50017

	INX

LZ50017	STA ZPB

	STX ZPB+1

	CMP ZPD

	TXA

	SBC ZPD+1

	BCS NOPLPRN2 ;dont print

	LDA #$20

	STA PTR

	LDA XSM

	JMP SMLSQPCM





NOPLPRN4	RTS

HFCNGTR1	JSR RHSSLSUB

	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	TAX

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

	BNE NOPLPRN4 ;dont print

	;bcc noplprn4

	TXA ;how far down plane strip is

	BNE THUG1

	;fiddled data to print edge along top line

	LDY #<IGOTDA6

	STY ZPF

	LDY #>IGOTDA6

	STY ZPF+1

	LDY #<IGETDA6

	STY ZPE

	LDY #>IGETDA6

	STY ZPE+1

THUG1	CMP YSM

	BCS NOPLPRN4 ;dont print

	STA ZPA

	AND #$08

	ASL ; = ASL A

	ASL ; = ASL A ;[*8]*4=*$20

	EOR #$20

	STA POS

	LDA SRT0 ;Qx lo

	STA ZPB

	CMP ZPD

	LDA SRT0+1 ;Qx hi

	STA ZPB+1

	SBC ZPD+1

	BCS NOPLPRN4 ;dont print

	LDA YSM

	SEC

	SBC ZPA

	SBC #8

	ASL ; = ASL A ;*2

	;clc

	ADC SRT0 ;Qx lo

	STA ZPC

	LDA SRT0+1 ;Qx hi

	ADC #0

	STA ZPC+1

	LDA ZPC

	CMP STRIPX

	LDA ZPC+1

	SBC STRIPX+1

	BCC NOPLPRN4 ;dont print

	LDY #1

	STY DATA

	DEY

	STY DATA+1

	LDA #$40

	JMP DRSTHSQSTR



NOPLPRN6	RTS

HFCNGTR2	JSR SIDSQSUB

	LDA SRT1 ;Qy lo

	CLC

	ADC XSM

	BCC LZ50019

	INC SRT1+1 ;Qy hi

LZ50019	STA SRT1 ;Qy lo

	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	TAX

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

	BNE NOPLPRN6 ;dont print

	;bcc noplprn6

	TXA ;how far down plane strip is

	BNE THUG2

	;fiddled data to print edge along top line

	LDY #<DTYDOGA

	STY ZPF

	LDY #>DTYDOGA

	STY ZPF+1

	LDY #<DTYDOGB

	STY ZPE

	LDY #>DTYDOGB

	STY ZPE+1

THUG2	CMP XSM

	BCS NOPLPRN6 ;dont print

	STA ZPA

	ASL ; = ASL A ;*2

	;clc

	ADC SRT0 ;Qx lo

	STA ZPB

	AND #0

	ADC SRT0+1 ;Qx hi

	STA ZPB+1

	LDA ZPB

	CMP ZPD

	LDA ZPB+1

	SBC ZPD+1

	BCS NOPLPRN6 ;dont print

	LDA XSM

	SEC

	SBC #8

	ASL ; = ASL A ;*2

	;clc

	ADC SRT0 ;Qx lo

	STA ZPC

	AND #0

	STA POS

	ADC SRT0+1 ;Qx hi

	STA ZPC+1

	LDA ZPC

	CMP STRIPX

	LDA ZPC+1

	SBC STRIPX+1

;;	BCC NOPLPRN6 ;dont print        ; Gives "Branch out of range"
	BCC NOPLPRN8    ; Both NOPLPRN6 and NOPLPRN8 are RTS

	LDY #0

	STY DATA

	INY

	STY DATA+1

	JMP DRSTHSQSTA





NOPLPRN8	RTS

HFCNGTR3	JSR RFTRPLQS

	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	TAX

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

	BNE NOPLPRN8 ;dont print

	;bcc noplprn8

	TXA

	LSR ; = LSR A ;/2

	CMP YSM

	BCS NOPLPRN8 ;dont print

	STX ZPA

	LDA SRT0 ;Qx lo

	STA ZPB

	CMP ZPD

	LDA SRT0+1 ;Qx hi

	STA ZPB+1

	TAX

	SBC ZPD+1

	BCS NOPLPRN8 ;dont print

	LDY #$C2

	;ldx srt0+1^^

	LDA ZPA

	CMP YSM

	BCC HSFCT3R

	LDY #0

	LDA YSM

	ASL ; = ASL A ;*2

	SEC

	SBC ZPA

	SBC #8

HSFCT3R	ASL ; = ASL A ;*2

	;clc

	ADC SRT0 ;Qx lo

	BCC LZ50021

	INX

LZ50021	STA ZPC

	STX ZPC+1

	LDA ZPC

	CMP STRIPX

	LDA ZPC+1

	SBC STRIPX+1

	BCC NOPLPRN8 ;dont print

	STY DATA+1

	LDA ZPA

	AND #$08

	ASL ; = ASL A

	ASL ; = ASL A ;[*8]*4=*$20

	EOR #$20

	STA POS

	LDA #1

	STA DATA

	LDA #$40

	JMP DRSTHSQSTR





NOPLPRNA	RTS

HFCNGTR4	JSR FCNG4SB

	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	TAX

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

	BNE NOPLPRNA ;dont print

	;bcc noplprna

	TXA

	LSR ; = LSR A ;/2

	CMP XSM

	BCS NOPLPRNA ;dont print

	STX ZPA

	LDY #0

	TXA

	LDX SRT0+1 ;Qx hi

	SEC

	SBC XSM

	BCS HFCN4LT

	LDY #$FE

	LDA XSM

	SEC

	SBC ZPA

	SBC #8

HFCN4LT	ASL ; = ASL A ;*2

	;clc

	ADC SRT0 ;Qx lo

	BCC LZ50022

	INX

LZ50022	STA ZPB

	STX ZPB+1

	STY DATA

	CMP ZPD

	TXA

	SBC ZPD+1

	BCS NOPLPRNA ;dont print

	LDX SRT0+1 ;Qx hi

	LDA XSM

	SEC

	SBC #8

	ASL ; = ASL A ;*2

	;clc

	ADC SRT0 ;Qx lo

	BCC LZ50023

	INX

LZ50023	STA ZPC

	STX ZPC+1

	CMP STRIPX

	TXA

	SBC STRIPX+1

	BCC NOPLPRNA

	LDA DATA

	BEQ LZ50025

	LDA #$20

LZ50025	STA POS

	LDA #1

	STA DATA+1

	JMP DRSTHSQSTA





NOPLPRNC	RTS

HPTPBOTL	JSR SIDSQSUB

	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	TAX

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

	BNE NOPLPRNC ;dont print

	;bcc noplprnc

	TXA

	CMP #$18

	BCS NOPLPRNC ;dont print

	ASL ; = ASL A

	ASL ; = ASL A ;[*8]*4=*$20

ONLY1TTP	STA POS



	LDA SRT0 ;Qx lo

	CMP ZPD

	LDA SRT0+1 ;Qx hi

	SBC ZPD+1

	BCS NOPLPRNC ;dont print

	;find how far across to start printing

	LDA SRT0 ;Qx lo

	SEC

	SBC STRIPX

	TAX

	LDA SRT0+1 ;Qx hi

	SBC STRIPX+1

	BCS PLHSTBT

	LDA STRIPX

	SEC

	SBC SRT0 ;Qx lo

	TAX

	LDA STRIPX+1

	SBC SRT0+1 ;Qx hi

	BNE NOPLPRNC ;dont print

	CPX #$10

	BNE NOPLPRNC ;dont print

	JMP PRHSTBT



PLHSTBT	JSR STRDALNG ;fix STRIPDAT



	LDY POS

	JSR DO1TRI

	LDA STRIPDAT

	CLC

	ADC #2

	BCC LZ50026

	INC STRIPDAT+1

LZ50026	STA STRIPDAT



PRHSTBT	LDA ZPD

	SEC

	SBC SRT0 ;Qx lo

	CMP #$10

	BEQ NOPLPRNC ;finish printing

	LDA POS

	CLC

	ADC #$60

	TAY

	JMP DO1TRI





ONL1TTPPJ	LDA #$40

ONLY1TTPJ	JMP ONLY1TTP

NOPLPRNE	RTS

HPMBYTEOTL	JSR SIDSQSUB

	LDY #$D

	LDA (ZPG),Y ;zdim

	SEC

	SBC #$10

	BEQ NOPLPRNE

	STA XSM

	LDA SRT1 ;Qy lo

	CLC

	ADC #$10

	BCC LZ50027

	INC SRT1+1 ;Qy hi

LZ50027	STA SRT1 ;Qy lo

HPOLENT	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	TAX

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

	BNE NOPLPRNE ;dont print

	;bcc noplprne

	CPX XSM ;zdim

	BEQ ONL1TTPPJ

	BCS NOPLPRNE ;dont print

	TXA

	BEQ ONLY1TTPJ

	ASL ; = ASL A

	ASL ; = ASL A ;[*8]*4=*$20

	AND #$20

	BNE ONLY1TTPJ



	LDA SRT0 ;Qx lo

	CMP ZPD

	LDA SRT0+1 ;Qx hi

	SBC ZPD+1

	BCS NOPLPRNE ;dont print

	;find how far across to start printing

	LDA SRT0 ;Qx lo

	SEC

	SBC STRIPX

	TAX

	LDA SRT0+1 ;Qx hi

	SBC STRIPX+1

	BCS PLHSMBTL

	LDA STRIPX

	SEC

	SBC SRT0 ;Qx lo

	TAX

	LDA STRIPX+1

	SBC SRT0+1 ;Qx hi

	BNE NOPLPRNE ;dont print

	CPX #$10

	BNE NOPLPRNE ;dont print

	JMP PRHSMBTL



PLHSMBTL	JSR STRDALNG ;fix STRIPDAT

	AND #0

	STA POS

	LDA #$40

	STA POS+1

	JSR DO2SECS

	LDA STRIPDAT

	CLC

	ADC #2

	BCC LZ50028

	INC STRIPDAT+1

LZ50028	STA STRIPDAT



PRHSMBTL	LDA ZPD

	SEC

	SBC SRT0 ;Qx lo

	CMP #$10

	BEQ NOPLPRNG ;finish printing

	LDA #$60

	STA POS

	LDA #$A0

	STA POS+1

	JMP DO2SECS

NOPLPRNG	RTS





PRHPOLE	JSR SIDSQSUB

	LDY #$D

	LDA (ZPG),Y ;zdim

	STA XSM

	JMP HPOLENT





HPRSDTDR	JSR SIDSQSUB

HEPRHHP	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	TAX

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

	BNE NOPLPRNG ;dont print

	;bcc noplprng

	CPX #$18

	BCS NOPLPRNG ;dont print

	TXA

	ASL ; = ASL A

	ASL ; = ASL A ;[*8]*4=*$20

	STA POS



	LDA SRT0 ;Qx lo

	CMP ZPD

	LDA SRT0+1 ;Qx hi

	SBC ZPD+1

	BCS NOPLPRNG ;dont print

	;find how far across to start printing

	LDA SRT0 ;Qx lo

	SEC

	SBC STRIPX

	TAX

	LDA SRT0+1 ;Qx hi

	SBC STRIPX+1

	BCC NOPLPRNG ;dont print

	JSR STRDALNG ;fix STRIPDAT

	LDY POS

	JMP DO1TRI





RHPSDTDR	JSR SIDSQSUB

	LDA SRT0 ;Qx lo

	CLC

	ADC #$10

	BCC LZ50029

	INC SRT0+1 ;Qx hi

LZ50029	STA SRT0 ;Qx lo

	JMP HEPRHHP





NOPLPRNH	RTS

HPTPTRDR	JSR SIDSQSUB

	LDA SRT1 ;Qy lo

	SEC

	SBC #8

	BCS LZ50030

	DEC SRT1+1 ;Qy hi

LZ50030	STA SRT1 ;Qy lo

	LDA STRIPY

	SEC

	SBC SRT1 ;Qy lo

	TAY

	LDA STRIPY+1

	SBC SRT1+1 ;Qy hi

	BNE NOPLPRNH ;dont print

	;bcc noplprnh

	CPY #$08

	BCC LZ50031

	BNE NOPLPRNH ;dont print

	LDY #$20



LZ50031	LDA SRT0 ;Qx lo

	CMP ZPD

	LDA SRT0+1 ;Qx hi

	SBC ZPD+1

	BCS NOPLPRNH ;dont print

	;find how far across to start printing

	LDA SRT0 ;Qx lo

	SEC

	SBC STRIPX

	TAX

	LDA SRT0+1 ;Qx hi

	SBC STRIPX+1

	BCS PLHSTTD

	LDA STRIPX

	SEC

	SBC SRT0 ;Qx lo

	TAX

	LDA STRIPX+1

	SBC SRT0+1 ;Qx hi

	BNE NOPLPRNH ;dont print

	CPX #$10

	BNE NOPLPRNH ;dont print

	TYA

	CLC

	ADC #$40

	TAY

	JMP PRHSTTD



PLHSTTD	JSR STRDALNG ;fix STRIPDAT;YR not affected

	JSR DO1TRI

	LDA STRIPDAT

	CLC

	ADC #2

	BCC LZ50032

	INC STRIPDAT+1

LZ50032	STA STRIPDAT

	TYA

	CLC

	ADC #$20

	TAY



PRHSTTD	LDA ZPD

	SEC

	SBC SRT0 ;Qx lo

	CMP #$10

;;	BEQ NOPLPRNH ;finish printing   ; Gives "Branch out of range"
        BEQ NOPLPRNJ ; Both NOPLPRNH and NOPLPRNJ are RTS

	JMP DO1TRI

NOPLPRNJ        RTS





;TABMAP	WORD MAP1,SHUT1

;	WORD MAP2,SHUT2

;	WORD MAP4,SHUT4

;	WORD MAP3,SHUT3

;	WORD MAP5,SHUT5

;

;SETMAP	LDA #1

;	STA SRA

;SETMAZ	;**CALL WHEN BUNG LAST BOTTLE**

;	LDA STAGE

;	ASL ; = ASL A

;	ASL ; = ASL A ;*4

;	TAY

;	LDA TABMAP,Y

;	STA CURMAP

;	STA ZPA

;	STA IX

;	LDA TABMAP+1,Y

;	STA CURMAP+1

;	STA ZPA+1

;	STA IX+1

;	DEC SRA

;	BNE RETSM

;	LDA STARY+$02

;	BEQ HAVNE

;	LDA #<STARY

;	STA ZPA

;	LDA #>STARY

;	STA ZPA+1

;HAVNE	LDY #0 ;PUT START Z-CO INTO PLAYER IX BLOCK

;	LDA (ZPA),Y

;	AND #$F0

;	STA IXTAB+$06 ;z-co (lo)

;	STA ZPB ;TEMP

;	;PUT START X-CO INTO PLAYER IX BLOCK

;	LDA (ZPA),Y

;	AND #$0F

;	CLC

;	ADC #$20

;	STA IXTAB+$02 ;x-co hi

;	TAX

;	INY

;	LDA (ZPA),Y

;	STA IXTAB+$03 ;x-co lo

;	;DO BIGX

;	SEC

;	SBC #$68

;	BCS SETM1

;	DEX

;	SEC

;SETM1	SBC ZPB

;	BCS SETM2

;	DEX

;S;ETM2	STA BIGX

;	STX BIGX+1

;	;DO PLAYER Y-CO START

;	INY

;	LDA (ZPA),Y ;Y-CO HI

;	STA IXTAB+$04 ;y-co hi

;	TAX

;	INY

;	LDA (ZPA),Y ;Y-CO LO

;	STA IXTAB+$05 ;y-co lo

;	;DO BIGY

;	SEC

;	SBC #$68

;	BCS SETM3

;	DEX

;SETM3	CLC

;	ADC ZPB

;	BCC SETM4

;	INX

;	CLC

;SETM4	STA BIGY

;	STX BIGY+1

;	;ADJUST CO-ORDS

;	LDA IXTAB+$05 ;Y-CO LO

;	ADC #$04 ;no carry

;	STA IXTAB+$05

;	LDA IXTAB+$03 ;X-CO LO

;	ADC #$02

;	STA IXTAB+$03

;RETSM	RTS



FIN

