;;*****************************************************************************
;;
;; File: C64KernalEntryPoints.asm
;;
;; Entry points for user-callable Commodore 64 Kernal [sic] routines
;;*****************************************************************************

C64_KERN_ACPTR  EQU $FFA5 ; = 65445 - Input byte from serial port
C64_KERN_CHKIN  EQU $FFC6 ; = 65478 - Open channel for input
C64_KERN_CHKOUT EQU $FFC9 ; = 65481 - Open channel for output
C64_KERN_CHRIN  EQU $FFCF ; = 65487 - Input character from channel
C64_KERN_CHROUT EQU $FFD2 ; = 65490 - Output character to channel
C64_KERN_CIOUT  EQU $FFA8 ; = 65448 - Output byte to serial port
C64_KERN_CINT   EQU $FF81 ; = 65409 - Initialize screen editor
C64_KERN_CLALL  EQU $FFE7 ; = 65511 - Close all channels and files
C64_KERN_CLOSE  EQU $FFC3 ; = 65475 - Close a specified logical file
C64_KERN_CLRCHN EQU $FFCC ; = 65484 - Close input and output channels
C64_KERN_GETIN  EQU $FFE4 ; = 65508 - Get character from keyboard queue (keyboard buffer)
C64_KERN_IOBASE EQU $FFF3 ; = 65523 - Returns base address of I/O devices
C64_KERN_IOINIT EQU $FF84 ; = 65412 - Initialize input/output
C64_KERN_LISTEN EQU $FFB1 ; = 65457 - Command devices on the serial bus to LISTEN
C64_KERN_LOAD   EQU $FFD5 ; = 65493 - Load RAM from a device
C64_KERN_MEMBOT EQU $FF9C ; = 65436 - Read/set the bottom of memory
C64_KERN_MEMTOP EQU $FF99 ; = 65433 - Read/set the top of memory
C64_KERN_OPEN   EQU $FFC0 ; = 65472 - Open a logical file
C64_KERN_PLOT   EQU $FFF0 ; = 65520 - Read/set X,Y cursor position
C64_KERN_RAMTAS EQU $FF87 ; = 65415 - Initialize RAM, allocate tape buffer, set screen $0400
C64_KERN_RDTIM  EQU $FFDE ; = 65502 - Read real time clock
C64_KERN_READST EQU $FFB7 ; = 65463 - Read I/O status word
C64_KERN_RESTOR EQU $FF8A ; = 65418 - Restore default I/O vectors
C64_KERN_SAVE   EQU $FFD8 ; = 65496 - Save RAM to device
C64_KERN_SCNKEY EQU $FF9F ; = 65439 - Scan keyboard
C64_KERN_SCREEN EQU $FFED ; = 65517 - Return X,Y organization of screen
C64_KERN_SECOND EQU $FF93 ; = 65427 - Send secondary address after LISTEN
C64_KERN_SETLFS EQU $FFBA ; = 65466 - Set logical, first, and second addresses
C64_KERN_SETMSG EQU $FF90 ; = 65424 - Control KERNAL messages
C64_KERN_SETNAM EQU $FFBD ; = 65469 - Set file name
C64_KERN_SETTIM EQU $FFDB ; = 65499 - Set real time clock
C64_KERN_SETTMO EQU $FFA2 ; = 65442 - Set timeout on serial bus
C64_KERN_STOP   EQU $FFE1 ; = 65505 - Scan stop key
C64_KERN_TALK   EQU $FFB4 ; = 65460 - Command serial bus device to TALK
C64_KERN_TKSA   EQU $FF96 ; = 65430 - Send secondary address after TALK
C64_KERN_UDTIM  EQU $FFEA ; = 65514 - Increment real time clock
C64_KERN_UNLSN  EQU $FFAE ; = 65454 - Command serial bus to UNLISTEN
C64_KERN_UNTLK  EQU $FFAB ; = 65451 - Command serial bus to UNTALK
C64_KERN_VECTOR EQU $FF8D ; = 65421 - Read/set vectored I/O

