@echo off
rem ***************************************************************************
rem * File: make.bat
rem *       Windows build script for cross-compiling Commodore 64 version of
rem *       Bubbler.
rem *
rem * Run: make.bat -- to build version without cheat keys
rem *      make.bat enhanced -- to build version with cheat keys etc (see
rem *                           Bubbler.asm for more details)
rem *
rem * Requires: DASM assembler      \_ See default
rem *           Exomizer compresser /  locations below
rem *
rem * Output: bubbler.prg -- boot loader
rem *         bubbler-main.prg -- main program (compressed)
rem *
rem *         bubbler-main.o64 -- main program (uncompressed)
rem *         bubbler-main.sym.txt -- Symbol table for main program (for debugging)
rem *
rem ***************************************************************************

rem Paths for Assembler & Compressor
set dasm_path=..\dasm
set exomizer_path=..\exo20beta7\win32

rem Handle build variants
set define=
if /i "%1" equ "enhanced" set define=-DBUILD_ENHANCED_VERSION

rem @echo on
rem for %%F in (bubbler.prg bubbler-main.o64 bubbler-main.sym.txt) do (del %%F)
echo ************************vvv Compilation of loader vvv*************************
@echo on
%dasm_path%\dasm BubblerLoader.asm -f1 -obubbler.prg -sbubbler-loader.sym.txt
@echo off
echo ************************^^^^^^ Compilation of loader ^^^^^^*************************
echo ***********************vvv Compilation of main prog vvv***********************
@echo on
%dasm_path%\dasm Bubbler.asm -f1 %define% -obubbler-main.o64 -sbubbler-main.sym.txt
@echo off
echo ***********************^^^^^^ Compilation of main prog ^^^^^^***********************

set /p continue=Continue to compression (Y/N)?

if /i "%continue%" equ "n" goto :all_done

@echo on
%exomizer_path%\exomizer.exe sfx basic bubbler-main.o64 -p 1 -o bubbler-main.prg -x1
@echo off

:all_done


